


//////////////////////////////////////////////////////////////
//	File: INTGRADE.CPP
//	Author: Scott Badman
//	Location: Parkland College, CSC 125
//
// Purpose: Test program for Integer class
//////////////////////////////////////////////////////////////
#include <iostream.h>
#include "integer.cpp"   // inclusion of Integer definition file

void main() {

	Integer x;

	// test of default constructor and insertion operator <<
	cout << "x with default constructor should be 0: " << x << endl;

	// test of int conversion constructor
	Integer y(4);
	cout << "y with conversion constructor should be 4: " << y << endl;

	// test of copy constructor
	Integer result(y);
	cout << "result with copy constructor should be 4: " << result << endl;

	// test of extraction operator >>
	cout << "Input an integer into x: ";
	cin >> x;
   cout << "this should be what you entered: " << x << endl;

	// test of assignment operator=
	x = 12;
	cout << "x = 12 should be 12: " << x << endl;

	// result was last left at 4
	// test of +=
	result += 3;
	cout << "result += 3 should equal 7: " << result << endl;

	// test of -=
	result -= y;
	cout << "result -= y should equal 3: " << result << endl;

	// test of *=
	result *= 8;
	cout << "result *= 8 should equal 24: " << result << endl;

	// test of /=
	result /= y;
	cout << "result *= y should equal 6: " << result << endl;

	// test of normal addition
	result = x + y;
	cout << "x + y should be 16: " << result << endl;

	// test of normal subtraction
	result = x - y;
	cout << "x - y should be 8: " << result << endl;

	// test of normal multiplication
	result = x * y;
	cout << "x * y should be 48: " << result << endl;

	// test of normal division
	result = x / y;
	cout << "x / y should be 3: " << result << endl;

	// test of modulo
	result = x % 5;
   cout << "x % 5 should be 2: " << result << endl;

	// test of prefix ++
	++x;
	cout << "prefix ++x should be 13: " << x << endl;

	// test of prefix --
	--x;
	cout << "prefix --x should be 12: " << x << endl;

	// test of postfix ++
	cout << "postfix x++ expression x + y++ should be 16: " << (x + y++) << endl;
	cout << "after expression y should be 5: " << y << endl;

	// test of postfix --
	cout << "postfix x++ expression x + y-- should be 17: " << (x + y--) << endl;
	cout << "after expression y is should be 4: " << y << endl;

	// test of unary +
	cout << "unary y should be 4: " << +y << endl;

	// test of unary -
	cout << "unary -y should be -4: " << -y << endl;

	// test of boolean operators.  x is still 12 and y is still 4
	if (y < x)
		cout << "less than operator< works properly" << endl;
	else
		cout << "less than operator< fails" << endl;

	if (y <= 4 && y <= x)
		cout << "less than or equal operator<= works properly" << endl;
	else
		cout << "less than or equal operator<= fails" << endl;

	if (x > y)
		cout << "greater than operator> works properly" << endl;
	else
		cout << "greater than operator> fails" << endl;

	if (x >= 12 && x >= y)
		cout << "greater than or equal operator>= works properly" << endl;
	else
		cout << "greater than or equal operator>= fails" << endl;

	if (y == 4)
		cout << "equality operator== works properly" << endl;
	else
		cout << "equality operator== fails" << endl;

	if (y != x)
		cout << "inequality operator!= works properly" << endl;
	else
		cout << "inequality operator!= fails" << endl;

	// test for integer overflow
	x = 754333455L;
	y = 822344234L;
	result = x + y;
	cout << "result should be NAN due to additive overflow: " << result << endl;
	result = 0;
	result = x - -y;
	cout << "result should be NAN due to substrative overflow: " << result << endl;
	result = 0;
	result = 2 * x;
	cout << "result should be NAN due to multiplicative overflow: " << result << endl;
	result = 0;

	// test for integer underflow
	result = -x + -y;
	cout << "result should be NAN due to additive underflow: " << result << endl;
	result = 0;
	result = -x - y;
	cout << "result should be NAN due to substractive underflow: " << result << endl;
	result = 0;
	result = -2 * y;
	cout << "result should be NAN due to multiplicative underflow: " << result << endl;
	result = 0;

	// test for divide by zero
	x = 12;
	y = 0;
	result = x / y;
	cout << "result should be NAN due to divide by zero: " << result << endl;

	// complex expressions
	x = 3;
	y = 4;
	Integer z = 5;

	result = (x * y) / 2 + z * 7;
	cout << "result of complex expression should be 41: " << result << endl;
	result = 0;

	result = (x * y) / 0 + z * 7;
	cout << "result of complex expression with divide by zero should be NAN: "
		  << result << endl;
        /*
	// test of compilation error on assignment int = Integer;
	int intx;
	intx = x;

	// test of compilation error on assignment long = Integer;
	long longx;
	longx = x;
          */
// >>>>>>>>>>>>>>> Additional tests from Roger Silis, Summer 1997.  Not checked out.

//    O P T I O N A L   !!!!!!!!!!!!!!!!!!!!!!!!!   O P T I O N A L
// test of  read in overflow
//	cin.ignore();
	cout << "Input a LONG  integer larger than 1 billion, x: ";
	cin >> x;
	cout << "this should be a NAN: " << x << endl;
	cin.ignore();

// test of  read in underflow
	cout << "Input a LONG  integer less than -1 billion, x: ";
	cin >> x;
	cout << "this should be a NAN: " << x << endl;
	cin.ignore();


//    O P T I O N A L   !!!!!!!!!!!!!!!!!!!!!!!!!   O P T I O N A L
	// test for divide/equal by zero
	result = 17;
	x = 0;
	result /=  x;
	cout << "result should be NAN due to divide/equal by zero: " << result << endl;

	// test for modulo by zero
	result = 17;
	x = 0;
	result = y % x;
	cout << "result should be NAN due to modulo by zero: " << result << endl;
        /*
	// test for modulo/equal by zero
	result = 17;
	x = 0;
	result %=  x;
	cout << "result should be NAN due to modulo/equal by zero: " << result << endl;
	  */

} // main
