/*-------------------------------------------------------
Integer.cpp by Sajeev Sivanesan
  Project for CSC125 for creating a safe data type NAN
  When executed will prevent overflow and divide by
  zero errors.
  Was written in Borland C++ 3.1
--------------------------------------------------------*/




#include "integer.h"

Integer::Integer() {
	dataIn = 0;

} // Integer::Integer, default constructor

Integer::Integer(long first) {

	if((first >1000000000)||(first<-1000000000))
		{
			nan=true;//sets bool var
			dataIn=1;//sets data to a safe state
		}//prevent data overflow
   else
	dataIn = first;//copies entered value to class integer variable
	
	
}//Integer::Integer, programmers constructor


Integer::Integer(const Integer& original)
 {
	if((original.dataIn>1000000000)||(original.dataIn<-1000000000))
		{
			nan=true;//sets bool var
			dataIn=1;//sets data to a safe state
		}//prevent data overflow
    else
	dataIn = original.dataIn;  

} // Integer::Integer , copy constructor

Integer::~Integer() {
}//Destructor

Integer&
Integer::operator=(const Integer& rightside) {

	if((rightside.dataIn>1000000000)||(rightside.dataIn<-1000000000))
		{
			nan=true;//sets bool var
			dataIn=1;//sets data to a safe state
			return *this;
		}//data overflow
    else
	dataIn = rightside.dataIn;

	return *this;
} // Integer::operator=

ostream&
operator<<(ostream& streamout, const Integer& value) {
	if(nan==true)//boolean var. set by mathmatical operators
	{
		streamout<<"NAN";//outputs NAN instead of Integer to a screen
		nan=false;//resets boolean operator for next value
		return streamout;
	}
	streamout << value.dataIn;//outputs integer
	nan=false;//resets boolean operator
	return streamout;
} // Integer::operator<<

istream&
operator>>(istream& streamin, Integer& value) {
	streamin >> value.dataIn;//inputs integer into memory
	if((value.dataIn > 1000000000) || (value.dataIn < 1000000000))
	{
		value.dataIn = 1;
		nan = true;
		return streamin;
	}
	return streamin;
} // Integer::operator>>

Integer
Integer::operator+() {
	Integer temp(*this);
	temp.dataIn = +temp.dataIn;
	if((temp.dataIn<-1000000000)||(temp.dataIn>1000000000))//true if NAN
	{
		temp.dataIn=1;//sets data to safe state
		nan=true;//sets (enum)boolean var
		return temp;
	}   

	return temp;
} // Integer::operator+

Integer
Integer::operator-() {
	Integer temp(*this);
	temp.dataIn = -temp.dataIn;
		if((temp.dataIn<-1000000000)||(temp.dataIn>1000000000))//true if NAN
	{
		temp.dataIn=1;//sets data to a safe state
		nan=true;//sets (enum) boolean var
		return temp;
	}   

	return temp;
} // Integer::operator-


Integer
Integer::operator++() {
	dataIn++;
	if((dataIn>100000000)||(dataIn<-100000000))//true if NAN
	{
		nan=true;//sets data to a safe state
		dataIn=1;//sets data to a safe state
		return *this;
   }
   return *this;
} // Integer::operator++

Integer
Integer::operator++(int ignore) {

	Integer temp(*this);
	++(*this);
	if((temp.dataIn>100000000)||(temp.dataIn<-100000000))//true if NAN
	{
		nan=true;//sets data to a safe state
		temp.dataIn=1;//sets data to a safe state
		return temp;
   }

	return temp;
} // Integer::operator++(int)

Integer
Integer::operator--() {
	dataIn--;
	if((dataIn>100000000)||(dataIn<-100000000))
	{
		nan=true;//sets bool var.
		dataIn=1;//sets data to a safe state
		return *this;
   }

	return *this;
} // Integer::operator--

Integer
Integer::operator--(int ignore) {

	Integer temp(*this);
	--(*this);
	if((temp.dataIn>100000000)||(temp.dataIn<-100000000))//true if NAN
	{
		nan=true;//sets bool to true
		temp.dataIn=1;//sets data to a safe state
		return temp;
	}
	return temp;
} // Integer::operator--(int)


Integer
operator+(const Integer& left, const Integer& right) {
	Integer temp(left);
	Integer q;//used in prediction of overflow of data
	q.dataIn = (left.dataIn/2)+(right.dataIn/2);//formula to determine overflow for +
	if(q.dataIn>500000000)//true if overflow, 500000000 is a predermined value for +
	{
		nan=true;//sets boolean var
		temp.dataIn=1;//sets data to a safe state
		return temp;
	}
	if(q.dataIn<-500000000)//true if overflow, 500000000 is a predermined value for +
	{
		nan=true;//sets boolean var
		temp.dataIn=1;//sets data to a safe state
		return temp;
	}
		temp += right;//performs addition operation

	return temp;
} // operator+

Integer
operator-(const Integer& left, const Integer& right) {
	Integer temp(left);
	Integer q;//used in predicting overflow
	q.dataIn=((left.dataIn/2)-(right.dataIn/2));//formula to determine overflow for /
	if((q.dataIn<-500000000)||(q.dataIn>500000000))//true if overflow, 50000000 is predetermined
		{
			nan=true;//sets boolean var
			temp.dataIn=1;//sets data to a safe state
			return temp;
		}

	temp -= right;//performs subtraction operation

	return temp;
} // operator-


Integer
operator*(const Integer& left, const Integer& right) {
	Integer temp(left);
	Integer q;//used in predicting if integers will overflow
	q.dataIn=(left.dataIn / 2) * (right.dataIn / 2);//formula to determine overflow for *
	if((q.dataIn > 25000000)||(q.dataIn<-25000000))//true if overflow, 25000000 is predetermined
	{
		nan=true;//sets boolean var
		temp.dataIn=1;//sets data to a safe state
		return temp;
	}
	temp *= right;//performs multiplication

	return temp;
} // operator*


Integer
operator/(const Integer& left, const Integer& right) {
	Integer temp(left);
	if(right==0)//divide by zero error
	{
		temp=1;//sets data to a safe state
		nan = true;//sets bool var to true
		return temp;
	}
	temp /= right;//performs division
	return temp;
} // operator/

Integer
operator%(const Integer& left, const Integer& right) {
	Integer temp(left);
	if(right==0)
	{
		temp=1;
		nan = true;
		return temp;
	}
	temp %= right;
	return temp;
} //operator %


Integer&
Integer::operator+=(const Integer& rightside) {
	if((rightside.dataIn>1000000000)||(rightside.dataIn<-1000000000))//true if NAN
		{
			dataIn=1;//sets data to a safe state
			nan=true;//sets bool to true
			return *this;
		}
	dataIn += rightside.dataIn;//performs addition
	if((dataIn>1000000000)||(dataIn<-1000000000))//true if NAN
		{
			dataIn=1;//sets data to a safe state
			nan=true;//sets bool to true
			return *this;
		}

	return *this;
} // Integer::operator+=


Integer&
Integer::operator-=(const Integer& rightside) {

	dataIn -= rightside.dataIn; //performs subtraction
	if((dataIn>1000000000)||(dataIn<-1000000000))//true if NAN
		{
			dataIn=1;//sets data to a safe state
			nan=true;//sets bool to true
			return *this;
		}

	return *this;
} // Integer::operator-=


Integer&
Integer::operator*=(const Integer& rightside) {
   
	dataIn = dataIn * rightside.dataIn;//performs multiplication
	if((dataIn>100000000)||(dataIn<-100000000))//true if NAN
	{
		dataIn=1;//sets data to a safe state
		nan=true;//sets bool to true
		return *this;
   }
	return *this;
} // Integer::operator*=


Integer&
Integer::operator/=(const Integer& rightside) {
	dataIn = dataIn / rightside.dataIn;
	if((dataIn>100000000)||(dataIn<-100000000))//true if NAN
	{
		dataIn=1;//sets data to a safe state
		nan=true;//sets bool to true
		return *this;
   }
	return *this;
} // Integer::operator/=
Integer&
Integer::operator%=(const Integer& rightside) {
	dataIn = dataIn % rightside.dataIn;
	return *this;
}


Integer
Integer::operator~() {
	Integer temp(*this);
	temp.dataIn = -dataIn;
	if((temp.dataIn>100000000)||(temp.dataIn<-100000000))
	{
		temp.dataIn=1;
		nan=true;
		return temp;
   }
	return temp;
} // Integer::operator~

bool
operator<(const Integer& left, const Integer& right) {
	bool result;
	result = left.dataIn<right.dataIn;
	return result;
} // operator<

bool
operator<=(const Integer& left, const Integer& right) {
	bool result;
	result = left.dataIn <= right.dataIn;
	return result;
} // operator<=

bool
operator>(const Integer& left, const Integer& right) {
	bool result;
	result = left.dataIn > right.dataIn;
	return result;
	} // operator>

bool
operator>=(const Integer& left, const Integer& right) {
  bool result;
  result = left.dataIn >= right.dataIn;
  return result;
} // operator>=

bool
operator==(const Integer& left, const Integer& right){
	bool result;
	result = left.dataIn == right.dataIn;
	return result;
} //operator ==

bool
operator!=(const Integer& left, const Integer& right) {
	bool result;
	result = left.dataIn != right.dataIn;
	return result;

} // operator!=
bool
operator||(const Integer& left, const Integer& right){
	bool result;
	result = left.dataIn || right.dataIn;
	return result;
}// operator ||


