/*------------------------------------------------------------
Integer.h by Sajeev Sivanesan to be used with Integer.cpp
Contains class Integer which is to be a safe data type.
Was written in Borland C++ 3.1
------------------------------------------------------------*/





#include <iostream.h>

enum bool {false, true};  // because Borland 4.5 does not have bool yet
bool nan;
class Integer {
public:

	Integer(); //Default Constructor
	Integer(long);// Programmer's Constructor
	Integer(const Integer&); 	    // Copy Constructor
	~Integer();
	Integer& operator=(const Integer&);//overloaded assignment operator


	friend ostream& operator<< (ostream&, const Integer&);
	friend istream& operator>> (istream&, Integer&);

	Integer operator-();
	Integer operator++();
	Integer operator++(int);
	Integer operator--();
	Integer operator--(int);
	Integer operator+();

	friend Integer operator+(const Integer&, const Integer&);
	friend Integer operator-(const Integer&, const Integer&);
	friend Integer operator*(const Integer&, const Integer&);
	friend Integer operator/(const Integer&, const Integer&);
   friend Integer operator%(const Integer&, const Integer&);

	Integer& operator+=(const Integer&);
	Integer& operator-=(const Integer&);
	Integer& operator*=(const Integer&);
	Integer& operator/=(const Integer&);
   Integer& operator%=(const Integer&);

	Integer operator~();

	friend bool operator<(const Integer&, const Integer&);
	friend bool operator<=(const Integer&, const Integer&);
	friend bool operator>(const Integer&, const Integer&);
	friend bool operator>=(const Integer&, const Integer&);
	friend bool operator==(const Integer&, const Integer&);
	friend bool operator!=(const Integer&, const Integer&);
	friend bool operator||(const Integer&, const Integer&);
protected:
  long dataIn;
  char error[4];
}; // class Integer

